package com.fs.starfarer.api.impl.campaign.rulecmd;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.campaign.OptionPanelAPI;
import com.fs.starfarer.api.campaign.rules.MemKeys;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import com.fs.starfarer.api.util.Misc;
import java.awt.Color;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.lwjgl.input.Keyboard;
import src.data.scripts.campaign.GladiatorSociety_Content;
import src.data.scripts.campaign.missions.GladiatorSociety_BountyMission_V2;

public class GladiatorSociety_GladiatorAvailable extends BaseCommandPlugin {

    public static final String GladiatorSociety_CONTENTKEY = "$GladiatorSociety_ContentKey";

    public GladiatorSociety_Content content;

    @Override
    public boolean execute(String ruleId, InteractionDialogAPI dialog, List<Misc.Token> params, Map<String, MemoryAPI> memoryMap) {

        if (content == null) {
            if (Global.getSector().getPersistentData().containsKey(GladiatorSociety_CONTENTKEY)) {
                content = (GladiatorSociety_Content) Global.getSector().getPersistentData().get(GladiatorSociety_CONTENTKEY);
            } else {
                content = new GladiatorSociety_Content();
                Global.getSector().getPersistentData().put(GladiatorSociety_CONTENTKEY, content);
            }
        }
        if (content == null) {
            return false;
        }

        String arg = params.get(0).getString(memoryMap);
        String exitOpt = "continueCutComm";
        int num = -1;
        if (params.size() > 1) {
            num = (int) params.get(1).getFloat(memoryMap);
        }
        switch (arg) {
            case "bountyAvailable":
                bountyAvailable(dialog, memoryMap.get(MemKeys.LOCAL));
                return true;
            case "bountyDisplay":
                if (num == -1) {
                    return true;
                }
                bountyDisplay(dialog, memoryMap.get(MemKeys.LOCAL), num);
                return true;
            case "Next":
                next();
                bountyAvailable(dialog, memoryMap.get(MemKeys.LOCAL));
                return true;
            case "Accept":
                if (num == -1) {
                    return true;
                }
                OptionPanelAPI opts = dialog.getOptionPanel();
                
                opts.clearOptions();

                dialog.getTextPanel().addParagraph("The mission have be accepted");
                // Global.getSector().getCampaignUI().addMessage("GladiatorSociety_BountyMission playerAccept");

                content.missions.get(num+content.getMaxConcurrent()*content.getNextSet()).playerAccept(Global.getSector().getPlayerFleet().getInteractionTarget());
                content.missions.remove(num+content.getMaxConcurrent()*content.getNextSet());
                content.resetNext();
                return true;

        }

        return false;
    }

    public void next() {
        content.incrementNext();
        if (content.getNextSet() * content.getMaxConcurrent()+1 > content.missions.size()) {
            content.resetNext();
        }
    }

    public void bountyAvailable(InteractionDialogAPI dialog, MemoryAPI memory) {

        OptionPanelAPI opts = dialog.getOptionPanel();
        opts.clearOptions();

        content.initPicker();
        int maxconcurrent = content.getMaxConcurrent();
        int next = content.getNextSet();
       // dialog.getTextPanel().addParagraph("next"+next);
        //GladiatorSociety_BountyMission_V2 mis;
        while ( (content.createMission()) != null) {
         //   dialog.getTextPanel().addParagraph(""+mis.getMissionID());
        }
       // dialog.getTextPanel().addParagraph(""+content.missions.size());
        Iterator<GladiatorSociety_BountyMission_V2> iter = content.missions.iterator();
        int i = 0;
        while (next > i) {
            int n = 0;
            while (iter.hasNext() && n < maxconcurrent) {
                iter.next();
                n++;
               // dialog.getTextPanel().addParagraph("n"+n);
            }
            i++;
          //  dialog.getTextPanel().addParagraph("i"+i);

        }
        int groupNum = 0;
        while (iter.hasNext() && groupNum < maxconcurrent) {
                String optionId = "gladiator_Bounty" + groupNum;
                opts.addOption(iter.next().getPerson().getName().getFullName(),
                        optionId, "Display the bounty");
                groupNum++;
        }
      
        
        opts.addOption("Next", "gladiator_Next", "Display the bounty");
      /*  if (content.getMaxConcurrent() <= content.missions.size()) {
                    opts.setEnabled("gladiator_Next", false);
        }*/
        String exitOpt = "gladiatorComRelay";

        opts.addOption(Misc.ucFirst("back"), exitOpt);
        opts.setShortcut(exitOpt, Keyboard.KEY_ESCAPE,
                false, false, false, false);

    }

    public void bountyDisplay(InteractionDialogAPI dialog, MemoryAPI memory, int num) {

        OptionPanelAPI opts = dialog.getOptionPanel();

        opts.clearOptions();

        GladiatorSociety_BountyMission_V2 mission = content.missions.get(num+content.getMaxConcurrent()*content.getNextSet());

        dialog.getTextPanel().addParagraph("Reward: " + mission.getReward() + " credits");
        float point = Global.getSector().getPlayerFleet().getFleetPoints();
        float pointGS = mission.getSupposedFleetPoints();
/*
        float difficulty = point - pointGS;
        int dif = 0;

        if (difficulty < -1 * (point / 10)) {
            dif--;
            if (difficulty < -1 * (point / 5)) {
                dif--;
                if (difficulty < -1 * point) {
                    dif--;
                }
            }
        } else {
            if (difficulty > (point / 5)) {
                dif++;
                if (difficulty > (point)) {
                    dif++;
                }
            }
        }*/
       /* String difmes = "Normal";
        Color dangercolor = Color.ORANGE;
        switch (dif) {
            case -3:
                difmes = "Impossible";
                dangercolor = Color.RED;
                break;
            case -2:
                difmes = "Very hard";
                dangercolor = Color.RED;
                break;
            case -1:
                difmes = "Hard";
                break;
            case 0:
                break;
            case 1:
                difmes = "Easy";
                dangercolor = Color.GREEN;
                break;
            case 2:
                difmes = "Very easy";
                dangercolor = Color.GREEN;

                break;
        }*/
        dialog.getTextPanel().addParagraph("Estimated Comparaison force : You(" + point+ ") Ennemi("+pointGS+")", Color.RED);
        //dialog.getTextPanel().highlightInLastPara(dangercolor, difmes);

        dialog.getTextPanel().addParagraph(mission.getBountyDescription());
        FactionAPI faction = Global.getSector().getFaction(mission.getBountyFaction());
        if (faction != null) {
            dialog.getTextPanel().addParagraph("Faction: " + faction.getDisplayNameLongWithArticle());
        }
        dialog.getTextPanel().addParagraph("WARNING: The fleet will appear near you.", Color.RED);
        opts.addOption("Accept", "Accept" + num, "Accept");
        opts.setShortcut("Accept" + num, Keyboard.KEY_G,
                false, false, false, false);

        String exitOpt = "gladiatorDirectoryMain";

        opts.addOption(Misc.ucFirst("back"), exitOpt);
        opts.setShortcut(exitOpt, Keyboard.KEY_ESCAPE,
                false, false, false, false);
    }

}
