package com.fs.starfarer.api.impl.campaign.rulecmd;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.campaign.OptionPanelAPI;
import com.fs.starfarer.api.campaign.SpecialItemData;
import com.fs.starfarer.api.campaign.rules.MemKeys;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import com.fs.starfarer.api.impl.campaign.ids.Items;
import com.fs.starfarer.api.util.Misc;
import java.awt.Color;
import java.util.List;
import java.util.Map;
import org.lwjgl.input.Keyboard;
import src.data.scripts.campaign.GladiatorSociety_EndlessContent;
import src.data.scripts.campaign.dataclass.*;
import src.data.scripts.campaign.missions.GladiatorSociety_GladiatorManager;

public class GladiatorSociety_GladiatorEndless extends BaseCommandPlugin {

    public static final String GladiatorSociety_ENDLESSCONTENTKEY = "$GladiatorSociety_EndlessContentKey";

    public GladiatorSociety_EndlessContent endcontent;

    @Override
    public boolean execute(String ruleId, InteractionDialogAPI dialog, List<Misc.Token> params, Map<String, MemoryAPI> memoryMap) {
        String arg = params.get(0).getString(memoryMap);

        if (endcontent == null) {
            if (Global.getSector().getPersistentData().containsKey(GladiatorSociety_ENDLESSCONTENTKEY)) {
                endcontent = (GladiatorSociety_EndlessContent) Global.getSector().getPersistentData().get(GladiatorSociety_ENDLESSCONTENTKEY);
            } else {
                endcontent = new GladiatorSociety_EndlessContent();
                Global.getSector().getPersistentData().put(GladiatorSociety_ENDLESSCONTENTKEY, endcontent);
            }
        }
        if (endcontent == null) {
            return false;
        }

        switch (arg) {
            case "Display":
                display(dialog, memoryMap.get(MemKeys.LOCAL));
                return true;
            case "Accept":
                accept(dialog, memoryMap.get(MemKeys.LOCAL));
                return true;
            case "Reward":
                reward(dialog, memoryMap.get(MemKeys.LOCAL));
                return true;
            case "Increment":
                endcontent.incEndlessRound();
                return true;
            case "Choice":
                int num = -1;
                if (params.size() > 1) {
                    num = (int) params.get(1).getFloat(memoryMap);
                } else {
                    return true;
                }
                GladiatorSociety_EndlessReward reward = endcontent.getCurrentRewardList().get(num);

                endcontent.addTakenReward(reward.id_Reward);
                
                switch (reward.rewardType) {
                    case 2:
                        if (reward.blueprint) {
                            Global.getSector().getPlayerFleet().getCargo().addSpecial(new SpecialItemData(Items.WEAPON_BP, reward.id_Resource), reward.number);
                        } else {
                            Global.getSector().getPlayerFleet().getCargo().addWeapons(reward.id_Resource, reward.number);
                        }
                        break;
                    case 3:
                        if (reward.blueprint) {
                            Global.getSector().getPlayerFleet().getCargo().addSpecial(new SpecialItemData(Items.FIGHTER_BP, reward.id_Resource), reward.number);
                        } else {
                            Global.getSector().getPlayerFleet().getCargo().addFighters(reward.id_Resource, reward.number);
                        }
                        break;
                    case 4:
                        Global.getSector().getPlayerFleet().getFleetData().addFleetMember(reward.id_Resource);
                        break;
                    case 5:
                        Global.getSector().getPlayerFleet().getCargo().addHullmods(reward.id_Resource, reward.number);
                        break;
                    case 6:
                        Global.getSector().getPlayerFleet().getCargo().addSpecial(new SpecialItemData(Items.INDUSTRY_BP, reward.id_Resource), reward.number);
                        break;
                    case 7:
                        Global.getSector().getPlayerFleet().getCargo().addSpecial(new SpecialItemData(Items.SHIP_BP, reward.id_Resource), reward.number);
                        break;
                    default:
                        break;
                }
                return true;

        }

        return false;
    }

    public void display(InteractionDialogAPI dialog, MemoryAPI memory) {

        OptionPanelAPI opts = dialog.getOptionPanel();
        opts.clearOptions();

        dialog.getTextPanel().addParagraph("Reward: " + endcontent.getEndlessReward() + " credits");
        dialog.getTextPanel().addParagraph("Round: " + endcontent.getEndlessRound());
        dialog.getTextPanel().highlightInLastPara(Color.BLUE, endcontent.getEndlessRound() + "");
        float point = Global.getSector().getPlayerFleet().getFleetPoints();
       /* float difficulty = point*3 - endcontent.getEndlessPower();
        int dif = 0;

        if (difficulty < -1 * (point / 10)) {
            dif--;
            if (difficulty < -1 * (point / 5)) {
                dif--;
                if (difficulty < -1 * point) {
                    dif--;
                }
            }
        } else {
            if (difficulty > (point / 5)) {
                dif++;
                if (difficulty > (point)) {
                    dif++;
                }
            }
        }
        String difmes = "Normal";
        Color dangercolor = Color.ORANGE;
        switch (dif) {
            case -3:
                difmes = "Impossible";
                dangercolor = Color.RED;
                break;
            case -2:
                difmes = "Very hard";
                dangercolor = Color.RED;
                break;
            case -1:
                difmes = "Hard";
                break;
            case 0:
                break;
            case 1:
                difmes = "Easy";
                dangercolor = Color.GREEN;
                break;
            case 2:
                difmes = "Very easy";
                dangercolor = Color.GREEN;

                break;
        }*/
        dialog.getTextPanel().addParagraph("Estimated Comparaison force : You(" + point+ ") Ennemi("+endcontent.getEndlessPower()+")", Color.RED);

     //   dialog.getTextPanel().addParagraph("Estimated Difficulty: " + difmes);
    //    dialog.getTextPanel().highlightInLastPara(dangercolor, difmes);

        //dialog.getTextPanel().addParagraph(difmes, dangercolor);
        dialog.getTextPanel().addParagraph("Reward: " + endcontent.getEndlessReward() + " credits");
        FactionAPI faction = Global.getSector().getFaction(endcontent.getEndlessFaction());
        if (faction != null) {
            dialog.getTextPanel().addParagraph("Faction: " + faction.getDisplayNameLongWithArticle());
        }
        dialog.getTextPanel().addParagraph("WARNING: The fleet will appear near you.", Color.RED);
        opts.addOption("Accept", "AcceptEndless", "Accept");
        opts.setShortcut("AcceptEndless", Keyboard.KEY_G,
                false, false, false, false);

        if (endcontent.canHaveReward()) {
            opts.addOption("Reward", "RewardEndless", "List special reward");
            opts.setEnabled("RewardEndless", true);
        } else {
            opts.addOption("Reward", "RewardEndless", "No reward available or no space available");
            opts.setEnabled("RewardEndless", false);
        }
        opts.setShortcut("RewardEndless", Keyboard.KEY_F,
                false, false, false, false);
        if (Global.getSettings().isDevMode()) {
            opts.addOption(">> (dev) Increment", "DevIncEndless", "Clic on the button will have the same effect than beat a round.");
            opts.setShortcut("AcceptEndless", Keyboard.KEY_D,
                    false, false, false, false);
        }

        String exitOpt = "gladiatorComRelay";
        opts.addOption(Misc.ucFirst("back"), exitOpt);
        opts.setShortcut(exitOpt, Keyboard.KEY_ESCAPE,
                false, false, false, false);
    }

    public void accept(InteractionDialogAPI dialog, MemoryAPI memory) {

        OptionPanelAPI opts = dialog.getOptionPanel();
        opts.clearOptions();
        GladiatorSociety_GladiatorManager.getInstance().createEvent(endcontent);
        dialog.getTextPanel().addParagraph("The mission have be accepted");
    }

    public void reward(InteractionDialogAPI dialog, MemoryAPI memory) {

        OptionPanelAPI opts = dialog.getOptionPanel();
        opts.clearOptions();

        List<GladiatorSociety_EndlessReward> list = endcontent.getCurrentRewardList();
        int inc = 0;
        for (GladiatorSociety_EndlessReward reward : list) {
            String text;
            switch (reward.rewardType) {
                case 2:
                    if (reward.blueprint) {
                        text = "Weapon Blueprint";
                    } else {
                        text = "Weapon";
                    }
                    break;
                case 3:
                    if (reward.blueprint) {
                        text = "Fighter Blueprint";
                    } else {
                        text = "Fighter";
                    }
                    break;
                case 4:
                    text = "Ship";
                    break;
                case 5:
                    text = "Hullmod";
                    break;
                case 6:
                    text = "Industry Blueprint";
                    break;
                case 7:
                    text = "Ship Blueprint";
                    break;
                default:
                    text = "Unknown";
            }
            opts.addOption(text, "endless_reward" + inc, reward.description);
            inc++;
        }

        String exitOpt = "gladiatorComRelay";

        opts.addOption(Misc.ucFirst("back"), exitOpt);
        opts.setShortcut(exitOpt, Keyboard.KEY_ESCAPE,
                false, false, false, false);

    }

}
