package src.data.scripts.campaign;

import com.fs.starfarer.api.Global;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;
import src.data.scripts.campaign.dataclass.GladiatorSociety_BountyData;
import src.data.scripts.campaign.missions.GladiatorSociety_BountyMission_V2;

public class GladiatorSociety_Content {
    protected transient List<GladiatorSociety_BountyData> entityPicker = new ArrayList<GladiatorSociety_BountyData>();

    private Set<String> set_GladiatorSociety_bounty_done = new HashSet<>();
    private Set<String> bounty_on = new HashSet<>();
    
    private int nextSet=0;
    
    public List<GladiatorSociety_BountyMission_V2> missions = new ArrayList<>();
    
    public void addBountyDone(String bounty) {
        ifNullDone();
        set_GladiatorSociety_bounty_done.add(bounty);
    }

    public void ifNullDone() {
        if (set_GladiatorSociety_bounty_done == null) {
            set_GladiatorSociety_bounty_done = new HashSet<>();
        }
    }

    public void ifNullOn() {
        if (bounty_on == null) {
            bounty_on = new HashSet<>();
        }
    }

    public void removeActiveBounty(String bounty) {
        ifNullOn();
        bounty_on.remove(bounty);
    }
    
    public void incrementNext(){
        nextSet++;
    }
    public void resetNext(){
        nextSet=0;
    }
    public int getNextSet(){
        return nextSet;
    }
    protected Object readResolve() {
        return this;
    }
    
    public void initPicker() {

        entityPicker = new ArrayList<>();

        ifNullDone();
        ifNullOn();

        int playerLevel = 40;
        if (Global.getSector().getPlayerFleet() != null) {
            playerLevel = Global.getSector().getPlayerFleet().getCommander().getStats().getLevel();
        }

        for (GladiatorSociety_BountyData bounty : GladiatorSociety_JSONBountyRead.getAllBountyCopy()) {


            if (bounty == null || bounty.missionid == null) {
                continue;
            }

            if (set_GladiatorSociety_bounty_done.contains(bounty.missionid)) {
                continue;
            }
            if (playerLevel < 30 && playerLevel * 15000 < bounty.bountyvalue) {
                continue;
            }
            if (bounty.needBounty != null && !set_GladiatorSociety_bounty_done.contains(bounty.needBounty)) {
                continue;
            }
            boolean cont = false;
            for (String present : bounty_on) {
                if (present != null && present.equals(bounty.missionid)) {
                    cont = true;
                    break;
                }
            }
            if (cont) {
                continue;
            }
    
            entityPicker.add(bounty);
        }
    }
    
    
    
    public GladiatorSociety_BountyMission_V2 createMission() {

        Random random = new Random();
        int size = entityPicker.size();
        if (size == 0) {
            return null;
        }
        int rand = random.nextInt(size);
        GladiatorSociety_BountyData target = entityPicker.remove(rand);
        if (target == null) {
            return null;
        }
        String faction = "gladiator";

        int days = 150;

        GladiatorSociety_BountyMission_V2 mission = new GladiatorSociety_BountyMission_V2(faction, target, days, this);

        this.bounty_on.add(target.missionid);
        this.missions.add(mission);

        return mission;
    }

    public int getMaxConcurrent() {
        return 3;
    }
    

}
