package src.data.scripts.campaign.missions;

import com.fs.starfarer.api.EveryFrameScript;
import com.fs.starfarer.api.Global;
import java.util.ArrayList;
import java.util.List;
import src.data.scripts.campaign.GladiatorSociety_EndlessContent;

public class GladiatorSociety_GladiatorManager implements EveryFrameScript {

	public static final String KEY = "$core_GladiatorManager";
	
	public static GladiatorSociety_GladiatorManager getInstance() {
		Object test = Global.getSector().getMemoryWithoutUpdate().get(KEY);
                if(test==null){
                    test= new GladiatorSociety_GladiatorManager();
                }
		return (GladiatorSociety_GladiatorManager) test; 
	}
	protected List<EveryFrameScript> active = new ArrayList<>();
	public GladiatorSociety_GladiatorManager() {		
		Global.getSector().getMemoryWithoutUpdate().set(KEY, this);
	}

	public void createEvent(GladiatorSociety_EndlessContent content) {
		EveryFrameScript intel = new GladiatorSociety_EventEndlessBattle_v2(content);
		if (intel.isDone()) intel = null;
                addActive(intel);
	}
        public EveryFrameScript createEvent(GladiatorSociety_BountyMission_V2 mission) {
		EveryFrameScript intel = new GladiatorSociety_EventMissionBattle_v2(mission);
		if (intel.isDone()) intel = null;
                addActive(intel);
                return intel;
	}
        @Override
	public void advance(float amount) {
		List<EveryFrameScript> remove = new ArrayList<>();
		for (EveryFrameScript event : active) {
			event.advance(amount);
			if (event.isDone()) {
				remove.add(event);
			}
		}
		active.removeAll(remove);
	}
	
	
	
	public void addActive(EveryFrameScript event) {
		if (event != null) {
			active.add(event);
		} 
	}

        @Override
	public boolean isDone() {
		return false;
	}
        @Override
	public boolean runWhilePaused() {
		return false;
	}
	public List<EveryFrameScript> getActive() {
		return active;
	}


	
}
